﻿# Créé par Cyrille, le 27/12/2019 en Python 3.4
# -*- coding: utf-8 -*-
import matplotlib.pyplot as plt
import csv
import numpy as np
from math import exp

'''
Ce fichier traite les résultats  la décharge du condensateur
'''

'''
fonction permettant de lire le fichier csv et de modifier la virgule par un point le cas échéant
'''
def readColCSV(fichier,sep,n) :
    file=open(fichier,"r")
    reader=csv.reader(file,delimiter=sep)
    col=[]
    for row in reader :
        if(row[n][0].isdigit()) :
            notation_point=row[n].replace(",",".")
            col.append(float(notation_point))
    return col

fichier=input("Quel est le nom du fichier de pointage (sans l'extension .csv)?")+".csv"

'''
Appel de la fonction pour récupérer et lire les données.(tension en première colonne, durée en seconde colonne)
'''
time=readColCSV(fichier, ";",0)
tension=readColCSV(fichier,";",1)

#####à décocher pour tracer la courbe ln(E-
tensionbis=[maxi - tension[val] for val in range(len(tension))]
lntension=np.log(tensionbis)
times=[valeur/1000 for valeur in time]


fit=np.polyfit(times, lntension, 1)
regression=[fit[1]+fit[0]*temp for temp in times]
tau=-1/fit[0]
print(tau)

'''
Réalisation d'une grille avec des sous-divisions
'''
plt.grid(which="major",linestyle='-',linewidth=1, color='black')
plt.grid(which="minor",linestyle='--')
ax=plt.gca()
ax.minorticks_on()

'''
tracé des données expérimentales
'''
plt.title(r" $\ln(E-u_\mathrm{C})=f(t)$")
plt.plot(times, lntension, 'rs', label='Points expérimentaux')
plt.plot(times, regression, 'b', label='Régression linéaire : y='+str(fit[1])+'-'+str(fit[0])+r'$\times$ t')
plt.xlabel('$t$ (s)')
plt.ylabel('$\ln(E-u_{\mathrm{C}})$ (V)')
plt.legend()
plt.show()